/***************************************************************************
 *   Copyright (C) 2009 by Lassi Väätämöinen   *
 *   lassi.vaatamoinen@ixonos.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ALERTWAITERTHREAD_H
#define ALERTWAITERTHREAD_H

#include <QThread>
#include "QBittorrentSession.h"


/**
	@author Lassi Väätämöinen <lassi.vaatamoinen@ixonos.com>
*/
class AlertWaiterThread : public QThread
{
	Q_OBJECT
	
	public:
		AlertWaiterThread(TorrentSession *const session, QObject *parent = 0);

    virtual ~AlertWaiterThread();

		void allAlerts(bool enable = true);
		
		virtual void run(); // Overridden from QThread
		
	signals:
		void alert(TorrentAlert const *alert);
		
	private:
		TorrentSession *const btSession_;

};

#endif
