/***************************************************************************
 *   Copyright (C) 2009 by Lassi Väätämöinen   *
 *   lassi.vaatamoinen@ixonos.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QBITTORRENTSESSION_H
#define QBITTORRENTSESSION_H

#include <memory>

#include <QObject>

#include <libtorrent/session.hpp>
#include <libtorrent/torrent_info.hpp>

#include "QTorrentHandle.h"


// Forward declarations and typedefs
class AlertWaiterThread;
typedef libtorrent::session TorrentSession;
typedef libtorrent::add_torrent_params AddTorrentParams;
typedef libtorrent::alert TorrentAlert;
typedef libtorrent::sha1_hash Sha1Hash;


/**
	@author Lassi Väätämöinen <lassi.vaatamoinen@ixonos.com>
*/
class QBittorrentSession : public QObject {
	Q_OBJECT
//		class	BitTorrentSession;
			
	public:
		QBittorrentSession(QObject *parent = 0);
    ~QBittorrentSession();
		
		/// @brief Add torrent to session.
		std::auto_ptr<QTorrentHandle> addTorrent(AddTorrentParams const& params);
		
	signals:
		void alert(std::auto_ptr<TorrentAlert> al);
		
	private slots:
		void on_alert(TorrentAlert const *al);
		
	private:
		TorrentSession btSession_;
		AlertWaiterThread *alertWaiter_;
		
};

#endif
