/***************************************************************************
 *   Copyright (C) 2009 by Lassi Väätämöinen   *
 *   lassi.vaatamoinen@ixonos.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QTORRENTHANDLE_H
#define QTORRENTHANDLE_H

#include <QtGlobal>

#include <libtorrent/torrent_handle.hpp>


typedef libtorrent::torrent_status TorrentStatus;
typedef libtorrent::torrent_info TorrentInfo;

/**
	@author Lassi Väätämöinen <lassi.vaatamoinen@ixonos.com>
*/
class QTorrentHandle 
{
	
	public:
		QTorrentHandle(libtorrent::torrent_handle handle);
    ~QTorrentHandle();
		

		TorrentStatus status() const;
		
		TorrentInfo const& getTorrentInfo() const;
		
		bool isValid() const;

		QString name() const;
		size_t getTotalSize() const;
		QString state() const;
		float progress() const;
		float uploadRate() const;
		float downloadRate() const;
		qint32 numSeeds() const;
		qint32 numLeeches() const;
		qint32 ratio() const;
		

		bool operator==(QTorrentHandle const& h); 
		bool operator<(QTorrentHandle const& h);
		
	private:
		QTorrentHandle(); // Prevent default construct.
		libtorrent::torrent_handle torrentHandle_;
		
		// Private functions.
		QString GetStatusString(TorrentStatus const& status) const;
};

#endif
